## ifrit 3.2.0

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-#  Copyright (c) 2002-2006 Nick Gnedin 
+#  Copyright (c) 2002-2007 Nick Gnedin 
 #  All rights reserved.
 #
 #  This file may be distributed and/or modified under the terms of the
@@ -13,9 +13,10 @@
 SET(target ifrit)
 PROJECT(${target})
 
-SET(addOGL 0 CACHE BOOL "Add OpenGL manually")
-SET(addX11 0 CACHE BOOL "Add X11 manualy")
-MARK_AS_ADVANCED(addOGL addX11)
+SET(AddOGL 0 CACHE BOOL "Add OpenGL manually")
+SET(AddX11 0 CACHE BOOL "Add X11 manualy")
+SET(UseOffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
+MARK_AS_ADVANCED(AddOGL AddX11 UseOffScreen)
 
 IF(NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
@@ -30,7 +31,11 @@
 #
 #  Shells
 #
-OPTION(Shell:CL "Include command-line shell" ON)
+IF(WIN32)
+	OPTION(Shell:CL "Include command-line shell" OFF)
+ELSE(WIN32)
+	OPTION(Shell:CL "Include command-line shell" ON)
+ENDIF(WIN32)
 OPTION(Shell:QT "Include Qt-based GUI shell" ON)
 
 SET(nsh)
@@ -49,26 +54,56 @@
 ENDIF(NOT nsh AND NOT gsh)
 
 #
-#  Extensions
-#
-FILE(GLOB dir ${src}/core/extensions/hart) 
-IF(EXISTS ${dir})
-	OPTION(Extension:HART "Include HART extension" ON)
-ENDIF(EXISTS ${dir})
-
-FILE(GLOB dir ${src}/core/extensions/mv) 
-IF(EXISTS ${dir})
-	OPTION(Extension:MultiView "Include MultiView extension" ON)
-ENDIF(EXISTS ${dir})
-
+#  Find max extension flag
+#
+SET(maxNum 1)
+FILE(READ ${src}/configure/iextensiondefines.h f)
+
+STRING(REGEX MATCHALL "#define IEXTENSION_[A-Z0-9_]*[ \t]*[0-9]*" m ${f})
+IF(m)
+	STRING(REGEX REPLACE "#define IEXTENSION_[A-Z0-9_]*[ \t]*([0-9]*)" "\\1;" num ${m})
+	SET(num ${num}0)
+	FOREACH(n ${num})
+		IF(n GREATER ${maxNum})
+			SET(maxNum ${n})
+		ENDIF(n GREATER ${maxNum})
+	ENDFOREACH(n ${num})
+ENDIF(m)
+
+#
+#  Configure extensions
+#
 SET(ext)
-IF(Extension:HART)
-	SET(ext ${ext} hart)
-ENDIF(Extension:HART)
-
-IF(Extension:MultiView)
-	SET(ext ${ext} mv)
-ENDIF(Extension:MultiView)
+FILE(GLOB dir ${src}/configure/.CMake.*.def)
+
+IF(dir)
+	FOREACH(s ${dir})
+		STRING(REGEX REPLACE ".*\\.CMake\\.([A-Z0-9_]*)\\.def" "\\1" e ${s}) 
+		IF(e STREQUAL MV)
+			OPTION(Extension:MultiView "Include MultiView extension" OFF)
+			IF(Extension:MultiView)
+				set(ext ${ext} ${e})
+			ENDIF(Extension:MultiView)
+		ELSE(e STREQUAL MV)
+			OPTION(Extension:${e} "Include ${e} extension" ON)
+			IF(Extension:${e})
+				set(ext ${ext} ${e})
+			ENDIF(Extension:${e})
+#
+#  Check that the define for this extension has been set already.
+#			
+			STRING(REGEX MATCH "#define IEXTENSION_${e}[ \t]*[0-9]*" m ${f})
+			IF(NOT m)
+
+				MESSAGE("Extension ${e} has not been defined in configure/iextensiondefines.h.\n I will define it for you.")
+				SET(maxNum 2*${maxNum})
+				FILE(APPEND ${src}/configure/iextensiondefines.h "#define IEXTENSION_${e} ${maxNum}\n")
+
+			ENDIF(NOT m)
+
+		ENDIF(e STREQUAL MV)
+	ENDFOREACH(s ${dir})
+ENDIF(dir)
 
 #
 # ---------------------------------------------------------------------------
@@ -101,22 +136,22 @@
 ENDIF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)
 
 # Find OpenGL
-IF(addOGL)
+IF(AddOGL)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindOpenGL.cmake)
 	IF(NOT OPENGL_FOUND)
 		MESSAGE(FATAL_ERROR "OpenGL is not found. Please set advanced variables OPENGL_INCLUDE_DIR and OPENGL_LIBRARIES.")
 	ENDIF(NOT OPENGL_FOUND)
 	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
-ENDIF(addOGL)
+ENDIF(AddOGL)
 
 # Find X11
-IF(UNIX AND addX11)
+IF(UNIX AND AddX11)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
 	IF(NOT X11_FOUND)
 		MESSAGE(FATAL_ERROR "X11 is not found. Please set advanced variables X11_X11_INCLUDE_PATH and X11_LIBRARIES.")
 	ENDIF(NOT X11_FOUND)
 	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
-ENDIF(UNIX AND addX11)
+ENDIF(UNIX AND AddX11)
 
 IF(Shell:QT)
 	# Find Qt
@@ -169,18 +204,7 @@
 #  Extensions
 #
 FOREACH(e ${ext})
-	FILE(GLOB tmp ${src}/core/extensions/${e}/*.cpp)
-	IF(tmp)
-		SET(sources ${sources} ${tmp})
-		INCLUDE_DIRECTORIES(${src}/core/extensions/${e})
-		IF(gsh)
-			FILE(GLOB tmp ${src}/shells/generic/extensions/${e}/*.cpp)
-			SET(sources ${sources} ${tmp})
-			INCLUDE_DIRECTORIES(${src}/shells/generic/extensions/${e})
-		ENDIF(gsh)
-		STRING(TOUPPER ${e} ue)
-		SET(exten ${exten}+IEXTENSION_${ue})
-	ENDIF(tmp)
+	SET(exten ${exten}+IEXTENSION_${e})
 ENDFOREACH(e)
 
 #
@@ -225,6 +249,10 @@
 	ADD_DEFINITIONS(-DI_DEBUG -DI_CHECK2)
 ENDIF(CMAKE_BUILD_TYPE MATCHES "Debug")
 
+IF(UseOffScreen)
+	ADD_DEFINITIONS(-DI_OFFSCREEN)
+ENDIF(UseOffScreen)
+
 #
 #  Edition
 #
@@ -259,13 +287,13 @@
 	TARGET_LINK_LIBRARIES(${target} vtkVolumeRendering) 
 ENDIF(VTK_KITS MATCHES "VOLUMERENDERING")
 
-IF(addOGL)
+IF(AddOGL)
 	TARGET_LINK_LIBRARIES(${target} ${OPENGL_LIBRARIES}) 
-ENDIF(addOGL)
-
-IF(UNIX AND addX11)
+ENDIF(AddOGL)
+
+IF(UNIX AND AddX11)
 	TARGET_LINK_LIBRARIES(${target} ${X11_LIBRARIES})
-ENDIF(UNIX AND addX11)
+ENDIF(UNIX AND AddX11)
 
 IF(Shell:QT)
 	IF(QT_LIBRARIES)
