## ifrit 3.2.8

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,11 @@
 #  packaging of this file.
 #
 CMAKE_MINIMUM_REQUIRED(VERSION 2.0)
+
+IF(COMMAND cmake_policy)
+	cmake_policy(SET CMP0003 NEW)
+ENDIF(COMMAND cmake_policy)
+
 
 SET(src ..)
 SET(target ifrit)
