## ifrit 3.3.2

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,15 @@
 SET(AddX11 0 CACHE BOOL "Add X11 manualy")
 SET(UseOffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
 MARK_AS_ADVANCED(AddOGL AddX11 UseOffScreen)
+
+SET(StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")
+
+#
+#  Portability options
+#
+SET(Port:NoLongLong  0 CACHE BOOL "Do not use long long type")
+SET(Port:NoConsoleIO 0 CACHE BOOL "Disable console IO (must be set if conio.h include is not available)")
+MARK_AS_ADVANCED(Port:NoLongLong Port:NoConsoleIO)
 
 IF(NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
@@ -164,7 +173,7 @@
 	INCLUDE(${CMAKE_ROOT}/Modules/FindQt.cmake)
 	INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR})
 	IF(QT4_INSTALLED)
-		INCLUDE_DIRECTORIES(${QT_QT_INCLUDE_DIR})
+		INCLUDE_DIRECTORIES(${QT_INCLUDE_DIR}/Qt ${QT_QTCORE_INCLUDE_DIR})
 	ENDIF(QT4_INSTALLED)
 	ADD_DEFINITIONS(${QT_DEFINITIONS})
 ENDIF(Shell:QT)
@@ -268,6 +277,21 @@
 
 FILE(GLOB tmp ${src}/configure/iconfiguresettings.ext) 
 CONFIGURE_FILE(${tmp} ${tmp}.h @ONLY)
+
+IF(NOT StereoSupport)
+	ADD_DEFINITIONS(-DI_NO_STEREO)
+ENDIF(NOT StereoSupport)
+
+#
+#  Portability
+#
+IF(Port:NoLongLong)
+	ADD_DEFINITIONS(-DI_NO_LONG_LONG)
+ENDIF(Port:NoLongLong)
+
+IF(Port:NoConsoleIO)
+	ADD_DEFINITIONS(-DI_NO_CONSOLE_IO)
+ENDIF(Port:NoConsoleIO)
 
 #
 #  Add libraries
