## ifrit 3.3.4

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -18,19 +18,16 @@
 SET(target ifrit)
 PROJECT(${target})
 
-SET(AddOGL 0 CACHE BOOL "Add OpenGL manually")
-SET(AddX11 0 CACHE BOOL "Add X11 manualy")
-SET(UseOffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
-MARK_AS_ADVANCED(AddOGL AddX11 UseOffScreen)
-
-SET(StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")
+SET(Option:OffScreen 0 CACHE BOOL "Compile IFrIT for off-screen rendering (needs VTK with Mesa libraries)")
+SET(Option:StereoSupport 1 CACHE BOOL "Enable OpenGL support for displaying stereo (disable this option if you see flicker)")
 
 #
 #  Portability options
 #
+SET(Port:SearchOGL 0 CACHE BOOL "Search for OpenGL (normally should be found automatically)")
+SET(Port:SearchX11 0 CACHE BOOL "Search for X11 (normally should be found automatically)")
 SET(Port:NoLongLong  0 CACHE BOOL "Do not use long long type")
-SET(Port:NoConsoleIO 0 CACHE BOOL "Disable console IO (must be set if conio.h include is not available)")
-MARK_AS_ADVANCED(Port:NoLongLong Port:NoConsoleIO)
+MARK_AS_ADVANCED(Port:SearchOGL Port:SearchX11 Port:NoLongLong)
 
 IF(NOT CMAKE_BUILD_TYPE)
        SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
@@ -130,12 +127,12 @@
 MARK_AS_ADVANCED(CMAKE_BACKWARDS_COMPATIBILITY CMAKE_INSTALL_PREFIX LIBRARY_OUTPUT_PATH QT_QMAKE_EXECUTABLE)
 
 # Find curses
-INCLUDE(${CMAKE_ROOT}/Modules/FindCurses.cmake)
-IF(UNIX AND NOT CURSES_LIBRARY)
-	IF(Shell:CL)
-		MESSAGE(FATAL_ERROR "Curses library is not found, but is needed for Command-Line Shell. Please disable the Command-Line Shell option or install the curses library.")
-	ENDIF(Shell:CL)
-ENDIF(UNIX AND NOT CURSES_LIBRARY)
+IF(Shell:CL)
+	INCLUDE(${CMAKE_ROOT}/Modules/FindCurses.cmake)
+	IF(UNIX AND CURSES_LIBRARY)
+		ADD_DEFINITIONS(-DI_USE_CURSES)
+	ENDIF(UNIX AND CURSES_LIBRARY)
+ENDIF(Shell:CL)
 
 # Find VTK
 SET(VTK_DIR $ENV{VTKDIR})
@@ -150,22 +147,22 @@
 ENDIF(VTK_USE_VOLUMEPRO AND VTK_HAVE_VP1000)
 
 # Find OpenGL
-IF(AddOGL)
+IF(Port:SearchOGL)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindOpenGL.cmake)
 	IF(NOT OPENGL_FOUND)
 		MESSAGE(FATAL_ERROR "OpenGL is not found. Please set advanced variables OPENGL_INCLUDE_DIR and OPENGL_LIBRARIES.")
 	ENDIF(NOT OPENGL_FOUND)
 	INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
-ENDIF(AddOGL)
+ENDIF(Port:SearchOGL)
 
 # Find X11
-IF(UNIX AND AddX11)
+IF(UNIX AND Port:SearchX11)
 	INCLUDE(${CMAKE_ROOT}/Modules/FindX11.cmake)
 	IF(NOT X11_FOUND)
 		MESSAGE(FATAL_ERROR "X11 is not found. Please set advanced variables X11_X11_INCLUDE_PATH and X11_LIBRARIES.")
 	ENDIF(NOT X11_FOUND)
 	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
-ENDIF(UNIX AND AddX11)
+ENDIF(UNIX AND Port:SearchX11)
 
 IF(Shell:QT)
 	# Find Qt
@@ -241,13 +238,6 @@
 	ENDIF(tmp)
 ENDIF(CustomVP1000)
 
-IF(WIN32 AND NOT CYGWIN)
-	FILE(GLOB tmp ${src}/special/win32/*.rc)
-	IF(tmp)
-		SET(sources ${sources} ${tmp})
-	ENDIF(tmp)
-ENDIF(WIN32 AND NOT CYGWIN)
-
 #
 #  Create target
 #
@@ -263,9 +253,9 @@
 	ADD_DEFINITIONS(-DI_DEBUG -DI_CHECK2)
 ENDIF(CMAKE_BUILD_TYPE MATCHES "Debug")
 
-IF(UseOffScreen)
+IF(Option:OffScreen)
 	ADD_DEFINITIONS(-DI_OFFSCREEN)
-ENDIF(UseOffScreen)
+ENDIF(Option:OffScreen)
 
 #
 #  Edition
@@ -278,9 +268,9 @@
 FILE(GLOB tmp ${src}/configure/iconfiguresettings.ext) 
 CONFIGURE_FILE(${tmp} ${tmp}.h @ONLY)
 
-IF(NOT StereoSupport)
+IF(NOT Option:StereoSupport)
 	ADD_DEFINITIONS(-DI_NO_STEREO)
-ENDIF(NOT StereoSupport)
+ENDIF(NOT Option:StereoSupport)
 
 #
 #  Portability
@@ -288,10 +278,6 @@
 IF(Port:NoLongLong)
 	ADD_DEFINITIONS(-DI_NO_LONG_LONG)
 ENDIF(Port:NoLongLong)
-
-IF(Port:NoConsoleIO)
-	ADD_DEFINITIONS(-DI_NO_CONSOLE_IO)
-ENDIF(Port:NoConsoleIO)
 
 #
 #  Add libraries
@@ -342,8 +328,8 @@
 ENDIF(Shell:QT)
 
 IF(Shell:CL)
-	IF(UNIX)
+	IF(UNIX AND CURSES_LIBRARY)
 		TARGET_LINK_LIBRARIES(${target} curses) 
-	ENDIF(UNIX)
+	ENDIF(UNIX AND CURSES_LIBRARY)
 ENDIF(Shell:CL)
