## ifrit 3.4.2

=== build/CMakeLists.txt ===
--- 
+++ 
@@ -237,6 +237,14 @@
 		ADD_DEFINITIONS(-DI_CUSTOM_VP1000)
 	ENDIF(tmp)
 ENDIF(CustomVP1000)
+
+IF(Extension:ART)
+	FILE(GLOB tmp ${src}/special/artio/*.c)
+	IF(tmp)
+		SET(sources ${sources} ${tmp})
+		INCLUDE_DIRECTORIES(${src}/special/artio)
+	ENDIF(tmp)
+ENDIF(Extension:ART)
 
 #
 #  Create target
