=== debian/changelog ===
ifrit (3.4.2-1) unstable; urgency=low

  * QA upload.
  * New upstream release.
    + Drop existing patches.
  * Patch to link in libGL. (Closes: #713651).
  * Move debian/rules to dh style with cmake.
  * Move to source format 3.0 (quilt).
  * Add watch file.
  * Make VCS tag canonical.
  * Bump debhelper build-dep and compat to 9.
  * Bump Standards Version to 3.9.4.

 -- Barry deFreese <bdefreese@debian.org>  Thu, 11 Jul 2013 10:06:04 -0400

ifrit (3.3.4-4) unstable; urgency=low

  * QA upload.

  [ Ilya Barygin ]
  * Build-depend on libtiff-dev rather than libtiff4-dev.

 -- Colin Watson <cjwatson@debian.org>  Wed, 08 May 2013 16:18:57 +0100

ifrit (3.3.4-3) unstable; urgency=low

  * QA upload.
  * Fix "ftbfs with GCC-4.7": add patch 02-gcc-4.7.diff:
    declare SortWorker before using it.
    (Closes: #667207)
  * debian/rules: add build-{arch,indep} targets.

 -- gregor herrmann <gregoa@debian.org>  Wed, 02 May 2012 18:10:13 +0200

ifrit (3.3.4-2) unstable; urgency=low

  * QA upload.
  * Remove debian/watch. Upstream now links to Google Docs
    for download. I see now way to put that in a watch file.
  * vtk-tcl seems to have been renamed to tcl-vtk. Change
    Depends. (Closes: #619916)
  * Update homepage link.
  * Remove patch to allow build against VTK 5.4. 5.6 is used now.

 -- Frank Lichtenheld <djpig@debian.org>  Sat, 09 Apr 2011 14:36:03 +0200

ifrit (3.3.4-1) unstable; urgency=low

  * New upstream release.  Closes: #614433.
  * Rebuild against libqt4.  Closes: #604588.
  * Don't hardcode VTK version, no longer necessary.
  * Update debian/copyright.  Closes: #566582.
  * Orphan package.

 -- Mark Hymers <mhy@debian.org>  Fri, 18 Mar 2011 23:04:13 +0000

ifrit (3.3.2-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.8.3.  No changes needed.

 -- Mark Hymers <mhy@debian.org>  Sun, 13 Sep 2009 14:53:24 +0100

ifrit (3.2.8-1) unstable; urgency=low

  * New upstream release.

 -- Mark Hymers <mhy@debian.org>  Sun, 13 Sep 2009 13:41:27 +0100

ifrit (3.2.7-1) unstable; urgency=low

  * Add myself to Uploaders.
  * New upstream release for compatibility with VTK 5.2.
  * Update VTKDIR in debian/rules to /usr/lib/vtk-5.2. (Closes: #536904)
  * Drop RPATH from /usr/bin/ifrit.
  * Bump debhelper compatibility level to 7.
    - Add ${misc:Depends} to ifrit binary package.
    - Replace usages of deprecated `dh_clean -k` with `dh_prep`.
    - Remove calls to dh_desktop - it is a no-op now.
  * Add 01-gcc-4.3.diff to fix compilation with GCC 4.3.
  * Bump Standards-Version to 3.8.2.
  * Drop "Encoding=UTF-8" in debian/ifrit.desktop - it is now the default.
  * Clean CVS conflict files left in upstream tarball.
  * Add debian/watch file.

 -- Chris Lamb <lamby@debian.org>  Sat, 15 Aug 2009 12:29:10 +0100

ifrit (3.2.5-1) unstable; urgency=low

  * New upstream release.
  * Add Vcs-Browser and Vcs-Git fields.

 -- Mark Hymers <mhy@debian.org>  Sat, 28 Jun 2008 16:42:51 +0100

ifrit (3.2.4-1) unstable; urgency=low

  * New upstream release.
  * Remove dpatch support.
  * Bump Standards-Version to 3.8.0.

 -- Mark Hymers <mhy@debian.org>  Sun, 15 Jun 2008 21:33:02 +0100

ifrit (3.2.2-2) unstable; urgency=low

  * The "Running lintian on the right file considered helpful" release.
  * Move Homepage to source stanza
  * Use Applications/Science/Data Analysis as the menu section 

 -- Mark Hymers <mhy@debian.org>  Sat, 22 Dec 2007 17:51:09 +0000

ifrit (3.2.2-1) unstable; urgency=low

  * New upstream release.
  * Add patch to fix building with gcc-4.3.  Closes: #455164.
  * Bump Standards-Version to 3.7.3.
  * Move menu entry into Applications/Science instead of Apps/Science

 -- Mark Hymers <mhy@debian.org>  Wed, 19 Dec 2007 12:05:27 +0000

ifrit (3.2.0-1) unstable; urgency=low

  * New upstream release. 

 -- Mark Hymers <mhy@debian.org>  Fri, 31 Aug 2007 13:40:20 +0100

ifrit (3.1.5-1) unstable; urgency=low

  * New upstream release.  Closes: #420042.

 -- Mark Hymers <mhy@debian.org>  Sun, 22 Jul 2007 18:51:30 +0100

ifrit (3.1.0-1) unstable; urgency=low

  * New upstream version.
  * The "I'm bound to screw up my first non-sponsored upload" release.
  * Use VERBOSE=1 in make call so that buildd logs are useful.
  * Change VTKDIR to use /usr/lib/vtk-5.0 directly as /usr/lib/vtk
    appears not to be supplied now.  Yes, this'll make VTK changes
    more painful.
  * Add 01_no_patented.dpatch so we don't try and use any of the VTK
    patented interfaces which aren't in the Debian package.

 -- Mark Hymers <mhy@debian.org>  Sat,  7 Apr 2007 19:56:43 +0100

ifrit (3.0.5-1) unstable; urgency=low

  * New upstream version. 

 -- Mark Hymers <mark@hymers.org.uk>  Sat, 28 Oct 2006 15:06:32 +0100

ifrit (3.0.0-1) unstable; urgency=low

  * New upstream version.  Closes: #385517.

 -- Mark Hymers <mark@hymers.org.uk>  Wed, 30 Aug 2006 16:08:14 +0100

ifrit (2.9.6-2) unstable; urgency=low

  * Add a .desktop file from Phil Bull via Barry deFreese and Ubuntu.  Thanks
    to all concerned.  Closes: #376927.  Also add a dh_desktop call.
  * Bump standards version to 3.7.2.  No changes.

 -- Mark Hymers <mark.hymers@ncl.ac.uk>  Sat, 15 Jul 2006 16:10:54 +0100

ifrit (2.9.6-1) unstable; urgency=low

  * New upstream release.
  * Upstream has included Martin Michlmayr's patch to fix building on
    g++-4.1.  Closes: #357340.
  * Add -Wl,--as-needed as a flag to the link stage to reduce the
    number of libraries ifrit directly depends on (see
    http://lists.debian.org/debian-devel-announce/2005/11/msg00016.html
    for details)

 -- Mark Hymers <mark.hymers@ncl.ac.uk>  Fri, 17 Mar 2006 14:03:56 +0000

ifrit (2.9.4-1) unstable; urgency=low

  * New upstream release.

 -- Mark Hymers <mark.hymers@ncl.ac.uk>  Sat, 26 Nov 2005 14:02:48 +0000

ifrit (2.9.3-2) unstable; urgency=low

  * Rebuild for the C++ transition; needs vtk >= 4.4.2-8.  Closes: #327937
  * Newer version of debhelper will install menu file in /usr/share/menu

