=== debian/watch ===
version=3
http://astro.uchicago.edu/%7Egnedin/IFRIT/ifrit-src\.(.+)\.tar\.gz
