=== debian/changelog ===
ifrit (4.1.2-6) unstable; urgency=medium

  [ Adam Borowski ]
  * QA upload.
  * R³.
  * Move the VCS to Salsa.
  * Don't handle noopt and nostrip, already done by dpkg-buildflags.

  [ Peter Michael Green ]
  * Set DESIRED_QT_VERSION to 4 through a new override_dh_auto_configure target
    + Note: the package has a target called override_dh_autoconfigure which does
      nothing due to a typo in it's name, I tried fixing said typo but that
      seemed to cause more problems than it solved.
    (Closes: #897114)

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 06 May 2018 22:10:35 +0200

ifrit (4.1.2-5) unstable; urgency=medium

  * QA upload.
  [ Gert Wollny ]
  * debian/patches/vtk63_transition.patch
    - prepare for vtk 6.3 (Closes: #821105)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 15 Apr 2016 17:37:19 +0200

ifrit (4.1.2-4) unstable; urgency=medium

  * QA upload.
  * Revert last upload from Ralf, now vtk6 is fixed.
    (the issue was in vtk6, not in ifrit, and was affecting more
     packages)
  * Bump std-version to 3.9.8, no changes required.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 11 Apr 2016 10:11:38 +0200

ifrit (4.1.2-3) unstable; urgency=medium

  * QA upload
  * Add build-dependency on libhdf5-openmpi-dev (closes: #820545)

 -- Ralf Treinen <treinen@debian.org>  Sat, 09 Apr 2016 21:30:57 +0200

ifrit (4.1.2-2) unstable; urgency=medium

  * QA upload.
  * Drop hardcoded dependency on tcl-vtk.

 -- Adam Borowski <kilobyte@angband.pl>  Sun, 17 Jan 2016 16:17:19 +0100

ifrit (4.1.2-1) unstable; urgency=medium

  * QA upload.
  * New upstream release
    + Uses vtk6 (Closes: #803593)
  * Drop all quilt patches.
  * Drop the menu.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 14 Jan 2016 08:59:31 +0100

ifrit (3.4.2-2) unstable; urgency=medium

  * QA upload.
  * Use the CMake 3.2 way to find VTK.  (Closes: #788766)
  * Move packaging repository to collab-maint and import missing history.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 18 Jul 2015 18:09:06 +0200
