=== debian/control ===
Source: ifrit
Section: science
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 9), libvtk6-dev, libqt4-dev, libqt4-opengl-dev, cmake, libncurses5-dev, libtiff-dev, chrpath
Standards-Version: 4.1.4
Rules-Requires-Root: no
Homepage: http://sites.google.com/site/ifrithome/
Vcs-Git: https://salsa.debian.org/debian/ifrit
Vcs-Browser: https://salsa.debian.org/debian/ifrit

Package: ifrit
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: powerful tool for visualizing 3-dimensional data sets
 IFRIT (the Ionization FRont Interactive Tool) has its origins (and
 hence name) in a specialized utility designed to visualize ionization
 fronts in cosmological numerical simulations.  IFRIT, however, has
 outgrown its origins and now can visualize general data sets as well.
 .
 IFRIT is written in C++ and is based on two state-of-the-art toolkits:
 the Visualization ToolKit (VTK) and a GUI toolkit QT.
